=== debian/changelog ===
tkdnd (2.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch to the default Tcl/Tk version from 8.5 which is to be removed
    from Debian (closes: #887925).

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 21 Mar 2018 23:17:28 +0300

tkdnd (2.6-1) unstable; urgency=low

  * Initial release (Closes: #642118)

 -- Hans-Christoph Steiner <hans@eds.org>  Sun, 18 Nov 2012 23:01:18 -0500
