=== debian/control ===
Source: tkdnd
Section: libs
Priority: optional
Maintainer: Hans-Christoph Steiner <hans@eds.org> 
Build-Depends: debhelper (>= 7.0.50~),
               tcl-dev,
               tk-dev
Standards-Version: 3.9.3
Homepage: https://sourceforge.net/projects/tkdnd/
Vcs-Git: git://anonscm.debian.org/collab-maint/tkdnd.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tkdnd.git;a=summary

Package: tkdnd
Architecture: any
Depends: ${shlibs:Depends},
         tk (>= 8.6.0) | tk8.5 | tk8.6,
         ${misc:Depends}
Recommends: pd-import
Description: adds native drag & drop capabilities to the Tk toolkit
 TkDND is an extension that adds native drag & drop capabilities to the Tk
 toolkit.  Under unix the drag & drop protocol in use is the XDND protocol
 version 4 (also used by the QT toolkit, KDE & GNOME Desktops).
