=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --with-tcl=/usr/lib --with-tk=/usr/lib

override_dh_auto_test:
	echo "'make test' doesn't work with tkdnd"

override_dh_install:
	dh_install
	cat Changelog | gzip -9c > debian/tkdnd/usr/share/doc/tkdnd/changelog.gz
	mv debian/tkdnd/usr/share/man/mann debian/tkdnd/usr/share/man/man3
	mv debian/tkdnd/usr/share/man/man3/tkDND.n  \
		debian/tkdnd/usr/share/man/man3/tkdnd.3tcl
	sed -i 's|^\.TH tkdnd n |.TH tkdnd 3tcl |' \
		debian/tkdnd/usr/share/man/man3/tkdnd.3tcl
