=== debian/watch ===
version=3
http://sf.net/tkdnd/tkdnd(.*).tar.gz
