=== debian/changelog ===
tkdnd (2.9.5-0.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Hans-Christoph Steiner ]
  * remove 'Recommends: pd-import', its not relevant and was a mistake

  [ Jelmer Vernooĳ
  * Migrate repository from alioth to salsa.

  [ Andreas Tille ]
  * New upstream version
    Closes: #929861
  * New Homepage
  * d/watch:
     - Point watch file to Github
     - Version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Use cmake
    Closes: #1119589
  * Hardening
  * d/copyright: Fix License name

 -- Andreas Tille <tille@debian.org>  Fri, 28 Nov 2025 09:11:50 +0100
