=== debian/control ===
Source: tkdnd
Standards-Version: 4.7.2
Maintainer: Hans-Christoph Steiner <hans@eds.org>
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 tcl-dev,
 tk-dev,
Vcs-Browser: https://salsa.debian.org/debian/tkdnd
Vcs-Git: https://salsa.debian.org/debian/tkdnd.git
Homepage: https://github.com/petasis/tkdnd

Package: tkdnd
Architecture: any
Depends:
 ${shlibs:Depends},
 tk | tk8.5 | tk8.6,
 ${misc:Depends},
Description: adds native drag & drop capabilities to the Tk toolkit
 TkDND is an extension that adds native drag & drop capabilities to the Tk
 toolkit.  Under unix the drag & drop protocol in use is the XDND protocol
 version 4 (also used by the QT toolkit, KDE & GNOME Desktops).
